/*
 * ring_queue.h
 *
 *  Created on: 2024621
 *      Author: psx
 */

#ifndef DRIVERS_RINGQUEUE_RING_QUEUE2_H_
#define DRIVERS_RINGQUEUE_RING_QUEUE2_H_


//#define RING_QUEUE_DEBUG //屾ӡRingQueueĵϢ

//typedef unsigned char RQ_ElementType2;//Ԫ
typedef uint16_t RQ_ElementType2;//Ԫ

typedef struct _ring_queue2
{
    RQ_ElementType2 *elems;
    int size;
    volatile int front, rear;
}RingQueue2;

//ʼ,贫뱣״̬ĽṹqʹõbufferbufferС
int InitRingQueue2(RingQueue2 *q, RQ_ElementType2 *buff, int size);

#define RingQueueFull2(q) (((q)->rear+1) % (q)->size == (q)->front)
#define RingQueueEmpty2(q) ((q)->front == (q)->rear)

//,
//ʹãʶ߿޸ĵrearȶȡ
int ShowRingQueue2(RingQueue2 *q);

//βԪe
int InRingQueue2(RingQueue2 *q,RQ_ElementType2 e);

//ӶɾԪ
int OutRingQueue2(RingQueue2 *q, RQ_ElementType2 *e);

//еԪظ
int RingQueueLength2(RingQueue2 *q);


#endif /* DRIVERS_RINGQUEUE_RING_QUEUE_H_ */
